/**
 * Created by dan on 6/14/17.
 */
public class StringUtilities {
    /**
     * @return `Hello World` as a string
     */
    public static String getHelloWorld() {
        String hello = "Hello World";
        return hello;
    }

    /**
     * @param firstSegment a string to be added to
     * @param secondSegment a string to add
     * @return the concatenation of two strings, `firstSegment`, and `secondSegment`
     */
    public static String concatenation(String firstSegment, String secondSegment){
        String conCat = firstSegment.concat(secondSegment);
        return conCat;
    }

    /**
     * @param firstSegment a string to be added to
     * @param secondSegment a string to add
     * @return the concatenation of an integer, `firstSegment`, and a String, `secondSegment`
     */
    public static String concatenation(int firstSegment, String secondSegment){
        String conCat2 = (firstSegment + secondSegment);
        return conCat2;
    }

    /**
     * @param input a string to be manipulated
     * @return the first 3 characters of `input`
     */
    public static String getPrefix(String input){
        String firstThree = input.substring(0, 3);        
        return firstThree;
    }

    /**
     * @param input a string to be manipulated
     * @return the last 3 characters of `input`
     */
    public static String getSuffix(String input){
        String lastThree = input.substring((input.length() - 3), (input.length()));
        return lastThree;
    }

    /**
     * @param inputValue the value to be compared
     * @param comparableValue the value to be compared against
     * @return the equivalence of two strings, `inputValue` and `comparableValue`
     */
    public static Boolean compareTwoStrings(String inputValue, String comparableValue){
        boolean stringEqual = inputValue.equalsIgnoreCase(comparableValue);        
        return stringEqual;
    }

    /**
     * @param inputValue the value input from user
     * @return the middle character of `inputValue`
     */
    public static Character getMiddleCharacter(String inputValue){
        int midCharLocation = (inputValue.length() - 1) / 2;  // gets index #
        char midChar = inputValue.charAt(midCharLocation);
        return midChar;
    }

    /**
     * @param spaceDelimitedString a string, representative of a sentence, containing spaces
     * @return the first sequence of characters
     */
    public static String getFirstWord(String spaceDelimitedString){
        int firstSpace = spaceDelimitedString.indexOf(" ");
        String firstWord = spaceDelimitedString.substring(0, firstSpace);        
        return firstWord;
    }

    /**
     * @param spaceDelimitedString a string delimited by spaces
     * @return the second word of a string delimited by spaces.
     */
    public static String getSecondWord(String spaceDelimitedString){
        // find index of first space
        int firstSpace = spaceDelimitedString.indexOf(" ");
        // find index of second space
        int secondSpace = spaceDelimitedString.indexOf(" ", firstSpace + 1);

        String secondWord;
        
        if (secondSpace > 0) {
            secondWord = spaceDelimitedString.substring(firstSpace, secondSpace);
        } else {
            secondWord = spaceDelimitedString.substring((firstSpace + 1),(spaceDelimitedString.length()));
        }

        return secondWord;
    }

    /**
     * @param stringToReverse
     * @return an identical string with characters in reverse order.
     */
    public static String reverse(String stringToReverse){
        // change string in stringbuilder
        StringBuilder reverseSB = new StringBuilder(stringToReverse);
        // use built-in stringbuilder reverse method and then change back to string
        String reverse = reverseSB.reverse().toString();
        
        return reverse;
    }
}
